.TH vncaddrbook 1 "21 April 2008" "RealVNC Ltd" "VNC Enterprise Edition"
.SH NAME
vncaddrbook \- VNC address book for X
.SH SYNOPSIS
.B vncaddrbook
.RI [ options ]
.SH DESCRIPTION
.B vncaddrbook
is an address book for managing Virtual Network Computing (VNC) connections.  This manual page documents VNC Enterprise Edition for the X window system.  

Using the address book, a VNC connection is saved to a text file (with \fI.vnc\fP extension) to \fB$HOME/.vnc/VNCAddressBook\fP by default.  VNC connections can be viewed in the address book in two different ways:  connections are ordered alphabetically under Alphabetic View.  Alternatively connections can be viewed and organised using Hierarchical View.   For VNC connections requiring a server password, a \fImaster password\fP can be used to protect the server password before saving to file.

.SH "OPTIONS (PARAMETERS)"
You can get a list of parameters by giving \fB\-help\fP as a command\-line option
to vncaddrbook.  Parameters can be turned on with \-\fIparam\fP or off with
\-\fIparam\fP=0.  Parameters which take a value can be specified as
\-\fIparam\fP \fIvalue\fP.  Other valid forms are \fIparam\fP\fB=\fP\fIvalue\fP
\-\fIparam\fP=\fIvalue\fP \-\-\fIparam\fP=\fIvalue\fP.  Parameter names are
case\-insensitive.

.TP 
.B \-AddressBook
The directory from which to load the address book.  Default is \fB$HOME/.vnc/VNCAddressBook\fP.

.TP 
.B \-PasswordExpiry
This option specifies the length of time, in seconds, for which the master password will be cached.  Default is 3600.

.TP 
.B \-MasterPassword
This option specifies the \fImaster password\fP used to encrypt a VNC connection server password.  The \fImaster password\fP is saved in encrypted form.

.TP
.B \-EncryptPassword 
This option specifies the default behaviour for saving passwords when creating new entries in the address book.  Valid choices are \fB0\fP (don't save the password), \fB1\fP (save the password to file), \fB2\fP (encrypt the password and then save to file), and \fB3\fP (always ask the user about saving the password).  The default value is \fB3\fP.

.TP 
.B \-Toolbar
Configure VNC address book to show the toolbar (default is on).

.TP 
.B \-ToolbarIconSize
This option specifies the size of icons (in pixels) for display in the toolbar.  Valid sizes are 16, 24, 32 or 48 (default is 24).

.TP 
.B \-Details
Configure VNC address book to show the Connections Details panel (default is on).

.TP 
.B \-StatusBar
Configure VNC address book to display the Status Bar (default is on).

.TP 
.B \-Alpha
Configure VNC address book to show the Alphabetic View initially  (the default).  Turning it off with \fB-Alpha=0\fP will show the Hierarchical View initially.

.TP
.B \-AdvancedOptions
Configure VNC address book to always show the Connection Properties dialog in \fIadvanced\fP mode for every connection.  Default is to show the Connection Properties dialog in \fIbasic\fP mode for every connection.

.SH "SEE ALSO"
.BR vncviewer (1),
.BR vncserver (1),
.BR vncconfig (1),
.BR vncpasswd (1),
.BR vnclicense (1),
.BR vnckeygen (1),
.BR Xvnc (1),
.BR x0vncserver (1),
.BR vncinitconfig (1)
.br 
http://www.realvnc.com
.SH "AUTHOR"
RealVNC Ltd.
