.TH vncconfig 1 "11 Jul 2005" "RealVNC Ltd" "VNC Enterprise Edition"
.SH NAME
vncconfig \- configure and control a VNC server
.SH SYNOPSIS
.B vncconfig
.RI [ parameters ] 
.br
.B vncconfig
.RI [ parameters ] 
.B \-connect
.IR host [: port ]
.br
.B vncconfig
.RI [ parameters ] 
.B \-disconnect
.br
.B vncconfig
.RI [ parameters ] 
.RB [ -set ] 
.IR Xvnc-param = value " ..."
.br
.B vncconfig
.RI [ parameters ] 
.B \-list
.br
.B vncconfig
.RI [ parameters ] 
.B \-listconnections
.br
.B vncconfig
.RI [ parameters ] 
\fB\-get\fP \fIXvnc-param\fP
.br
.B vncconfig
.RI [ parameters ] 
\fB\-desc\fP \fIXvnc-param\fP
.SH DESCRIPTION
.B vncconfig
is used to configure and control a running instance of Xvnc, or any
other X server with the VNC extension.  Note that it cannot be used to
control VNC servers prior to version 4. It can be run either in
interactive mode or in command-line mode.

.SH INTERACTIVE MODE
In interactive mode, the
.B vncconfig
command launches a graphical front-end to the VNC server. This serves three
purposes: to support clipboard transfer to and from VNC viewers; to support
the "query connection" feature of VNC server; and to provide a visual status
and configuration interface.

.P
Two command-line options are available in interactive mode:
.TP
\fB-nowin\fP
Do not display the \fBvncconfig\fP window. This is useful you want
clipboard or query connection support but don't wish to clutter the desktop.
If your window manager supports application status icons, then
.B vncconfig
will still install an icon that can be used to open the status/configuration
interface, or to quit the program.
.TP
\fB-iconic\fP
Make the \fBvncconfig\fP window iconified by default.

.SH COMMAND-LINE MODE
When run with any other command-line options, \fBvncconfig\fP is a
one-shot program used to configure or control Xvnc as appropriate.  It
can be used to tell Xvnc to connect or disconnect from listening
viewers, and to set and retrieve Xvnc's parameters.

Note that the DISPLAY environment variable or the \fB\-display\fP option
must be set as appropriate to control Xvnc.  If you run it on an ordinary X
server (or on a version 3 Xvnc) you will get an error message saying that there
is no VNC extension.
.SH OPTIONS
.TP
.B \-connect \fIhost\fP[:\fIport\fP]
Tells an Xvnc server to make a "reverse" connection to a listening VNC viewer
(normally connections are made the other way round - the viewer connects to the
server). \fIhost\fP is the host where the listening viewer is running. If it's
not listening on the default port of 5500, you can specify \fIhost:port\fP
instead.
.TP
.B \-disconnect
This causes Xvnc to disconnect from all viewers so that the VNC desktop is not
displayed anywhere.
.TP
[\fB-set\fP] \fIXvnc-param\fP=\fIvalue\fP
Sets an Xvnc parameter to the given value.  Note that some of Xvnc's parameters
are read only once at startup so that changing them in this way may not have
any effect.
.TP
.B \-list
Lists all the parameters supported by Xvnc.
.TP
.B \-listconnections
Lists the current connections to the VNC desktop.
.TP
.B \-get \fIXvnc-param\fP
Prints the current value of the given Xvnc parameter.
.TP
.B \-desc \fIXvnc-param\fP
Prints a short description of the given Xvnc parameter.
.SH PARAMETERS
.B vncconfig
also has parameters of its own which can be set on the command line.  These
should not be confused with Xvnc's parameters which are manipulated with the
\fB-set\fP, \fB-get\fP, \fB-list\fP and \fB-desc\fP options.

Parameters can be turned on with -\fIparam\fP or off with -\fIparam\fP=0.
Parameters which take a value can be specified as -\fIparam\fP \fIvalue\fP.
Other valid forms are \fIparam\fP\fB=\fP\fIvalue\fP -\fIparam\fP=\fIvalue\fP
--\fIparam\fP=\fIvalue\fP.  Parameter names are case-insensitive.
.TP
.B \-display \fIXdisplay\fP
Specifies the Xvnc server to control.
.TP
.B \-nowin
When run in interactive mode, don't put up a window.
.TP
.B \-iconic
When run in interactive mode, make the window iconified at startup.
.TP
.B \-poll \fImillis\fP
Some badly-behaved X applications change the contents of the clipboard without
notifying the rest of the system.  To cope with these applications, vncconfig
can be made to check the contents of the clipboard every \fImillis\fP
milliseconds to see if it has changed.

.SH SEE ALSO
.BR vncserver (1),
.BR vncviewer (1),
.BR vncaddrbook (1),
.BR vncpasswd (1),
.BR vnclicense (1),
.BR vnckeygen (1),
.BR Xvnc (1),
.BR x0vncserver (1),
.BR vncinitconfig (1)
.br
http://www.realvnc.com
.SH AUTHOR
RealVNC Ltd.

