.TH vnckeygen 1 "14 Apr 2007" "RealVNC Ltd" "Virtual Network Computing"
.SH NAME
vnckeygen \- generate a secure key for encrypted VNC sessions
.SH SYNOPSIS
.B vnckeygen
.RI [ options ]
.SH DESCRIPTION
.B vnckeygen
generates a secure key and stores it in $HOME/.vnc/private.key.  This key is
used by both the server and viewer applications to encrypt VNC sessions when
the RA2 security type is used, or to encrypt passwords when the RA2ne security
type is used.

Generating a secure key is a computationally expensive operation and the
probabilistic techniques used make it impossible to predict how long it will
take. By default, vnckeygen prints an indication of its progress to stdout,
although this can be supressed using the -q option.
.SH OPTIONS
.B vnckeygen
accepts the following command-line options:
.TP
.B \-f
Generate a new secure key even if a valid key already exists.  Note
that if a server's secure key is replaced, then any viewers that have
previously connected to it will recognise this and will issue a
warning to the user.
.TP
.B \-q
Do not display the progress of the key generation. Without this option,
vnckeygen prints a dot (.) for each number it considers for each of the two
secure key components, p and q.
.TP
.BI RSA_Private_Key_File= file
Save the generated key to
.I file
(default $HOME/.vnc/private.key).
.TP
.BI RSA_Modulus_Bits= bits
Generate a private key of length
.I bits
(default 2048).
.SH NOTES
.BR vncviewer " and " vncserver
will automatically generate a secure key when run by a user that does
not already have one. However, you will need to run
.B vnckeygen
explicitly if you need to run
.BR Xvnc " or " x0vncserver .
Encrypted connections (using the RA2 and RA2ne security types) are not
possible if no private key exists.
.SH FILES
.TP
$HOME/.vnc/private.key
The secure key.
.SH SEE ALSO
.BR vncserver (1),
.BR vncviewer (1),
.BR vncaddrbook (1),
.BR vncconfig (1),
.BR vncpasswd (1),
.BR vnclicense (1),
.BR Xvnc (1),
.BR x0vncserver (1),
.BR vncinitconfig (1)
.br
http://www.realvnc.com
.SH AUTHOR
RealVNC Ltd.
