.TH vnclicense 1 "11 Jul 2005" "RealVNC Ltd" "VNC Enterprise Edition"
.SH NAME
vnclicense \- install, remove or check VNC licenses
.SH SYNOPSIS
.BI "vnclicense -add " license-key
.br
.BI "vnclicense -remove " license-key
.br
.B vnclicense -check
.br
.B vnclicense -list
.SH DESCRIPTION
.BR vnclicense
manages license keys for VNC Enterprise Edition.
.SH OPTIONS
.BR vnclicense
accepts the following command-line options:
.TP
.BI "-add " license-key
Install license key
.IR license-key .
The license key will have been emailed to you when you purchased a
license for the software.
.TP
.BI "-remove " license-key
Remove license key
.IR license-key .
.I license-key
can be either a license key, in which case it is removed only if it is
currently installed, or a number, in which case the license key
identified by that number is removed. To see how your licenses are
numbered, run
.B vnclicense
-list. Note that trial licenses cannot be removed manually; they are
automatically removed when they expire.
.TP
.B -check
Verify that the number of desktops in use does not exceed the maximum
allowed.
.B vnclicense
displays the number of active
desktops, the maximum number of desktops and a breakdown of how many
desktops each user is running. It exits with a zero return code if and
only if there are desktops available.
.TP
.B -list
List your installed license keys, together with the number of desktops
for which they are valid and the date on which they were issued. Trial
license are also listed along with the number of days for which they
are valid.
.SH NOTES
On some platforms,
.B vnclicense
is installed with the setuid permission bit set. This is because these
platforms require root privileges in order to verify license
keys. However, in order to add or remove license keys,
.B vnclicense
must be run by the superuser.
.SH SEE ALSO
.BR vncserver (1),
.BR vncviewer (1),
.BR vncaddrbook (1),
.BR vncconfig (1),
.BR vncpasswd (1),
.BR vnckeygen (1),
.BR Xvnc (1),
.BR x0vncserver (1),
.BR vncinitconfig (1)
.br
http://www.realvnc.com
.SH AUTHOR
RealVNC Ltd.
