.TH vncpasswd 1 "11 Jul 2005" "RealVNC Ltd" "VNC Enterprise Edition"
.SH NAME
vncpasswd \- change password for VNC authentication
.SH SYNOPSIS
.B vncpasswd
.RI [ passwd-file ]
.SH DESCRIPTION
.B vncpasswd
allows you to set the password used to access VNC desktops when using
"traditional" VNC authentication (when UserPasswdVerifier is VncAuth).  It does
not affect VNC desktops which are using UNIX authentication (UserPasswdVerifier
is UnixAuth).

It stores an obfuscated version of the password in the given file (default
$HOME/.vnc/passwd).  The \fBvncserver\fP program runs \fBvncpasswd\fP if
necessary the first time you start a VNC desktop, and invokes \fBXvnc\fP with
the appropriate \fB\-PasswordFile\fP option.  \fBvncviewer\fP can also be given
a password file to use via the \fB\-passwd\fP option.

The password must be at least six characters long.  When allowing legacy
viewers to connect (SecurityType includes VncAuth) then only the first eight
characters are significant.  All characters of the password are significant
when using RA2 or RA2ne as the SecurityType.

Note that the stored password is \fBnot\fP encrypted securely - anyone who has
access to this file can trivially find out the plaintext password, so
\fBvncpasswd\fP always sets appropriate permissions (read and write only by the
owner).  However, when accessing a VNC desktop a challenge-response mechanism
or other encryption is used over the wire making it hard for anyone to crack
the password simply by snooping on the network.
.SH FILES
.TP
$HOME/.vnc/passwd
Default location of the VNC password file.
.SH SEE ALSO
.BR vncserver (1),
.BR vncviewer (1),
.BR vncaddrbook (1),
.BR vncconfig (1),
.BR vnclicense (1),
.BR vnckeygen (1),
.BR Xvnc (1),
.BR x0vncserver (1),
.BR vncinitconfig (1)
.br
http://www.realvnc.com
.SH AUTHOR
RealVNC Ltd.
